diff --git a/shlr/java/class.c b/shlr/java/class.c
index 4d6bf0666f1..0825acb401d 100644
--- a/shlr/java/class.c
+++ b/shlr/java/class.c
@@ -3789,6 +3789,9 @@ R_API RBinJavaAttrInfo *r_bin_java_line_number_table_attr_new(ut8 *buffer, ut64
 		if (!lnattr) {
 			break;
 		}
+		if (offset + 8 >= sz) {
+			break;
+		}
 		lnattr->start_pc = R_BIN_JAVA_USHORT (buffer, offset);
 		offset += 2;
 		lnattr->line_number = R_BIN_JAVA_USHORT (buffer, offset);
